Rendering a custom field with a URL pattern set and containing " :" in the value raises
Addressable::URI::InvalidURIError
Status: Closed Start date:

Priority: Normal Due date:

Assignee: Go MAEDA % Done: 0%
Category: Custom fields Estimated time: 0.00 hour
Target version: 4.2.11

Resolution: Fixed Affected version: 4.2.0
Description

An Addressable::URI::InvalidURIError occurs in Issues#show for certain values used to format a URL.
Steps to reproduce:
1. Create an issue custom field:

o Field format: Text
o Link values to URL.: https://example.com/%value%

1. Inside an issue:
o Set the custom field value to: Test :Test, i.e. Test, blank, colon, Test
o Save the issue

1. When the issue is about to be shown, an Addressable::URI::InvalidURIError occurs.

The error is caused by the url_from_pattern method in lib/redmine/field_format.rb. The issue can be solved by replacing the 5
occurrances of Addressable::URl.encode with URl.encode_www_form_component.

>> Addressable::URI.encode "Test :Test"
Traceback (most recent call last):
Addressable::URI::InvalidURIError (Invalid scheme format: 'Test ')

>> URI.encode_www_form_component "Test :Test"
=> "Test+%3ATest"

Best regards,
Thomas

Related issues:
Related to Redmine - Defect #32752: Ruby 2.7: Remove deprecated URI.escape/un... Closed
Has duplicate Redmine - Defect #38491: Invalid scheme format: ' VP1' Closed

Associated revisions

Revision 22205 - 2023-04-21 05:06 - Go MAEDA

Rendering a custom field with a URL pattern set and containing " :" in the value raises Addressable::URI::InvalidURIError (#38464).

Patch by Go MAEDA.

Revision 22206 - 2023-04-21 05:35 - Go MAEDA
Merged r22205 from trunk to 5.0-stable (#38464).

Revision 22207 - 2023-04-21 05:37 - Go MAEDA
Merged r22205 from trunk to 4.2-stable (#38464).

History

#1 - 2023-04-19 08:19 - Go MAEDA
- Related to Defect #32752: Ruby 2.7: Remove deprecated URI.escape/unescape added

2025-05-02 1/3



https://example.com/%value

#2 - 2023-04-19 08:20 - Go MAEDA
- Status changed from New to Confirmed

- Affected version changed from 5.0.4 to 4.2.0

#3 - 2023-04-19 09:08 - Go MAEDA
Thank you for suggesting the fix but some tests fail if you simply replace Addressable::URI.encode with URI.encode_www_form_component because
it encodes space characters as "+". My understanding is that space characters have to be encoded as "%20" in the path part.

Maybe we have to find another approach.

Failure:
Redmine: :FieldFormatTest#test_text_field _with_url_pattern_and_value_containing_a_space_should_format_as_link [
/path/to/redmine/test/unit/lib/redmine/field_format/field_format_test.rb:90]:

—-—— expected
+++ actual
@@ -1 +1 Q@

-"<a href=\"http://foo/foo%20bar\" class=\"external\">foo bar</a>"
+"<a href=\"http://foo/foo+bar\" class=\"external\">foo bar</a>"

rails test test/unit/lib/redmine/field_format/field_format_test.rb:85
N
Failure:

Redmine: :FieldFormatTest#test_text_field_with_url_pattern_should_encode_values [/path/to/redmine/test/unit/lib
/redmine/field_format/field_format_test.rb:106]:

——— expected
+++ actual
@@ -1 +1 @@

—"<a href=\"http://foo/foo%20bar#anchor\" class=\"external\">foo bar</a>"
+"<a href=\"http://foo/foo+bar#anchor\" class=\"external\">foo bar</a>"

rails test test/unit/lib/redmine/field_format/field_format_test.rb:101

#4 - 2023-04-20 12:00 - Go MAEDA

The issue can be fixed by using Addressable::URI.encode_component instead of Addressable::URIl.encode.

irb (main) :001:0> Addressable::URI.encode_component "Test :Test"
=> "Test%20:Test"

#5 - 2023-04-20 12:18 - Go MAEDA

- File 38464.patch added

- Subject changed from Addressable::URI::InvalidURIError in Issues#show to Rendering a custom field with a URL pattern set and containing " :" in
the value raises Addressable::URI::InvalidURIError

- Target version set to Candidate for next minor release

Here is a patch to fix the issue.

#6 - 2023-04-20 23:48 - Go MAEDA

- Target version changed from Candidate for next minor release to 4.2.11

Setting the target version to 4.2.11.

#7 - 2023-04-21 05:38 - Go MAEDA
- Status changed from Confirmed to Closed
- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch in r22205. Thank you for reporting the issue.

#8 - 2023-04-25 10:54 - Go MAEDA
- Has duplicate Defect #38491: Invalid scheme format: ' VP1' added
https://www.redmine.org/projects/redmine/repository/svn/revisions/22205

Files

38464.patch 2.81 KB 2023-04-20 Go MAEDA
